/*******************************************************
 *  $BB?5!G=%^%k%A%a!<%?!!(BPIC16F1783
 *$B!!!!!&EE05B,Dj!!!'(B0V to 4.096V
 *$B!!!!!&EEN.B,Dj!!!'(B0mA to 409.6mA
 *$B!!!!!&<~GH?tB,Dj!'(B1Hz to 3MHz$B!!(B1Hz$BC10L(B
 *$B!!!!!&@589GH=PNO!'(B10Hz to 1kHz
 *$B!!!!!&J}7AGH=PNO!'(B1kHz to 8MHz
 *******************************************************/
#include  <htc.h>
#include  "lcd_lib3.h"
#include  "i2c_lib3.h"

/***** $B%3%s%U%#%.%e%l!<%7%g%s@_Dj(B *********/
__CONFIG(FOSC_ECH & WDTE_OFF & PWRTE_OFF & MCLRE_ON & CP_OFF
        & CPD_OFF & BOREN_ON & CLKOUTEN_OFF & IESO_OFF & FCMEN_OFF);
__CONFIG(WRT_OFF & PLLEN_ON & STVREN_OFF & LVP_OFF);
/** $B%0%m!<%P%kJQ?tDj5A(B **/
unsigned int Upper, Period, Cnt;
unsigned char WaitFlag, Interval, Mode, OldMode, InitFlag, SinFlag;
unsigned long Volt, Curr, Regist, Freq, Index, temp;
unsigned char Cmsg[] = "x.xxx V xxx.x mA";
unsigned char Dmsg[] = "                ";
/* $B4X?t$N%W%m%H%?%$%T%s%0(B */
void ltostring(char digit, unsigned long data, char *buffer);
void Display(void);
unsigned int ADConv(unsigned char ch);
void UpDownSW(void);
void SineOut(void);
void PWMOutput(void);
void FreqCounter(void);
void Register(void);
/** $B@589GH$N%G!<%?(B 100$BJ,2rG=(B**/
unsigned char SineData[100] = {
    127,135,142,149,157,164,171,178,185,191,198,203,209,214,219,224,228,232,236,239,
    241,243,245,246,247,247,247,246,245,243,241,239,236,232,228,224,219,214,209,203,
    198,191,185,178,171,164,157,149,142,135,127,119,112,105, 97, 90, 83, 76, 69, 63,
     56, 51, 45, 40, 35, 30, 26, 22, 18, 15, 13, 11,  9,  8,  7,  7,  7,  8,  9, 11,
     13, 15, 18, 22, 26, 30, 35, 40, 45, 51, 56, 63, 69, 76, 83, 90, 97,105,112,119
};
/** $B@589GH<~GH?t@_DjMQ%G!<%?(B Up/Down$B%9%$%C%A$G@Z$jBX$((B**/
unsigned char Setting[19][2] ={
    {4,7},{3,7},{3,90},{3,132},{3,157},{3,174},{3,187},
    {3,196},{3,202},{3,208},{2,210},{1, 197},{8,85},
    {8,125},{8,152},{8,171},{8,185},{8,196},{8,205}
};
/** $B@589GH@8@.MQ%?%$%^#2@_DjCM(B ***/
unsigned long SetFreq[19] = {
    10,20,30,40,50,60,70,80,90,100,200,300,400,500,600,700,800,900,1000
};

/******** $B%a%$%s4X?t(B  ************************************/
void main(void) {
    int i;
    
    /** Set I/O Port ***/
    TRISA = 0xBF;                               // RA6,RA3$B$N$_=PNO@_Dj(B
    TRISB = 0xFF;                               // $BA4F~NO(B
    TRISC = 0x5F;                               // RC7,5$B$N$_=PNO(B
    TRISE = 0xFF;                               // RE3$B$N$_(B
    ANSELA = 0x0D;                              // RA0,2,3$B$N$_%"%J%m%0$K@_Dj(B
    ANSELB = 0x09;                              // RB0(AN12) RB3(CIN)$B$N$_%"%J%m%0(B
    OPTION_REGbits.nWPUEN = 0;                  // $B%W%k%"%C%WM-8z2=(B
    WPUC = 0x46;                                // RC1,2,6 $B%W%k%"%C%W(B
    WPUB = 0x30;                                // RB4,5 $B%W%k%"%C%W(B
    /** I2C$B=i4|2=(B **/
    SSPADD = 0x4F;                              // 100kHz@8MHz
    SSPCON1 = 0x38;                             // I2C$B%$%M!<%V%k(B
    SSPSTAT = 0;                                // $B>uBV%/%j%"(B
    /** $B%*%Z%"%s%W$N=i4|@_Dj(B **/
    OPA1CON = 0xC0;                             // OPA1IN+ OPA1OUT
    OPA2CON = 0xC2;                             // DAC In
    /** $B%3%s%Q%l!<%?$N=i4|@_Dj(B **/
    CM1CON0 = 0;                                // CM1$BL58z2=(B
    CM2CON0 = 0xF6;                             // C2OUT$B$"$j(B,ASYNC
    CM2CON1 = 0x2A;                             // VDAC, C2IN2-$BF~NO(B
    APFCON = 0x80;                              // $BBeBX%T%s@_Dj!"(BC2OUT$B$r(BRA6$B$KJQ99(B
    /** FVR$B=i4|@_Dj(B **/
    FVRCON = 0x8F;                              // 4.096V$B@_Dj(B
    /** DAC$B=i4|@_Dj(B **/
    DACCON0 = 0x88;                             // DACOUT$B$J$7(B,FVR$B;HMQ(B
    /** A/D$B%3%s%P!<%?$N=i4|@_Dj(B **/
    ADCON0 = 0x00;                              // Select AN0 OFF
    ADCON1 = 0xC7;                              // Fosc/8, FVR-VREF-$B!!1&5M$a(B
    ADCON2 = 0x02;                              // Trigger Disable, ADNREF
    /** $BJQ?t=i4|2=(B **/
    OldMode = 0xFF;                             // $B2a5n%b!<%I%j%;%C%H(B
    Interval = 0;                               // 1$BIC%+%&%s%?%j%;%C%H(B
    Upper = 0;                                  // $B%*!<%P!<%U%m!<%+%&%s%?%j%;%C%H(B
    WaitFlag = 0;                               // 1$BICBT$A%U%i%0%j%;%C%H(B
    InitFlag = 0;                               // $B=i2s%U%i%0%j%;%C%H(B
    Index = 0;                                  // $B<~GH?t@_Dj%+%&%s%?%j%;%C%H(B
    Period = 100;                               // $B6k7AGH=i4|CM(B100kHz$B$K%;%C%H(B
    /** LCD$B=i4|2=(B **/
    lcd_init();                                 // $B1U>=I=<(4o$N=i4|2=(B
    lcd_str("Start");                           // Start$B%a%C%;!<%8I=<((B
    /************ $B%a%$%s%k!<%W(B  **********************************/
    while (1) {
        /** $B>o;~7WB,9`L\$N=hM}$HI=<((B **/
        /** $BEE05F~NO(B **/
        ADCON1 = 0xC7;                          // Fosc/8, FVR-VREF-$B!!1&5M$a(B
        Volt = ADConv(0)-20;                    // AN0$B7WB,!!%*%U%;%C%HJd@5(B
        ltostring(4, Volt, Cmsg+2);             // $BJ8;z$KJQ49(B
        Cmsg[1] = Cmsg[2];                      // $B:G2<0L7e1&0\F0(B
        Cmsg[2] = '.';                          // $B>.?tE@DI2C(B
        /** $BEEN.F~NO(B **/
        Curr = ADConv(3) -135;                  // AN3$B7WB,!!%*%U%;%C%HJd@5(B
        ltostring(4, Curr, Cmsg+8);             // $BJ8;z$KJQ49(B
        /** $BI=<(=PNO(B ***/
        Cmsg[12] = Cmsg[11];                    // $B:G2<0L7e1&0\F0(B
        Cmsg[11] = '.';                         // $B>.?tE@DI2C(B
        lcd_cmd(0x80);                          // 1$B9TL\;XDj(B
        lcd_str(Cmsg);                          // $B8GDj%a%C%;!<%8I=<((B
        /** $BA*Br%9%$%C%A$N%A%'%C%/(B **/
        Mode = 0;
        Mode = !RC1 + 2*(!RC2) + 4*(!RC6);      // $BA*Br%9%$%C%AF~NO(B
        if(OldMode != Mode){                    // $B%9%$%C%AJQ99$+!)(B
            /** $B%9%$%C%AJQ99;~$N=i4|2=(B **/
            for(i=0; i<16; i++)                 // LCD$BI=<(%P%C%U%!%/%j%"(B
                Dmsg[i] = ' ';                  // $B%V%i%s%/=q$-9~$_(B
            InitFlag = 0;                       // $B=i2s%U%i%0%;%C%H(B
            OldMode = Mode;                     // $B2a5n%b!<%I99?7(B
            TMR0IE = 0;                         // $B%?%$%^(B0$B3d$j9~$_6X;_(B
            TMR1IE = 0;                         // $B%?%$%^#13d$j9~$_6X;_(B
            TMR2IE = 0;                         // $B%?%$%^#23d$j9~$_6X;_(B
            PSMC1EN = 0;                        // PSMC$B%b%8%e!<%kL58z2=(B
        }
        /** $BA*Br9`L\$N=hM}$HI=<((B ***/
        switch(Mode){
             case 0:                             // $B<~GH?t7WB,%b!<%I(B
                FreqCounter();                  // $B<~GH?t%+%&%s%H$HI=<(<B9T(B
                break;
            case 1:                             // $B@589GH=PNO%b!<%I(B
                SineOut();                      // $B@589GH$N=PNO<B9T(B
                break;
            case 2:                             // PWM$B=PNO%b!<%I(B
                PWMOutput();                    // $B6k7AGH$N=PNO<B9T(B
                break;
            default:
                break;
        }
        /*** Up/Down$B%9%$%C%AF~NO=hM}(B ***/
        UpDownSW();                             // $B%9%$%C%A=hM}<B9T(B
        delay_100ms(3);                         // $BB,Dj4V3VMQCY1d(B
    }
}
/********************************************************/
/*************************************
* $B%?%$%^3d$j9~$_=hM}4X?t(B
*************************************/
void interrupt isr(void){
    int i;

    if(TMR0IF){                                 // $B%?%$%^(B0$B3d$j9~$_$N>l9g(B
        TMR0IF = 0;                             // $B%?%$%^(B0$B3d$j9~$_%U%i%0%/%j%"(B
        OPTION_REG = Setting[Index][0];         // $B%W%j%9%1!<%i%;%C%H(B
        TMR0 = Setting[Index][1];               // $B%?%$%^(B0$B<~4|:F%;%C%H(B
        DACCON1 = SineData[Cnt++];              // $B=PNO%l%Y%k%;%C%H(B
        if(Cnt >= 100)                          // $B%5%s%W%j%s%0%+%&%s%?99?7(B
            Cnt = 0;                            // 100$B2s$G:G=i$KLa$9(B
    }
    else{
        if(TMR1IF){                             // $B%?%$%^#13d$j9~$_$N>l9g(B
            TMR1IF = 0;                         // $B%?%$%^(B1$B3d$j9~$_%U%i%0%/%j%"(B
            Upper++;                            // $B%*!<%P!<%U%m!<%+%&%s%?99?7(B
        }
        else{
            if(TMR2IF){                         // $B%?%$%^(B2$B3d$j9~$_$N>l9g(B
                TMR2IF = 0;                     // $B%?%$%^(B2$B3d$j9~$_%U%i%0%/%j%"(B
                Interval++;                     // 0.5$BIC%+%&%s%?99?7(B
                if(Interval == 1){              // $B:G=i$N3d$j9~$_$N>l9g(B
                    TMR1IE = 0;                 // 1$BICJd@5MQ%@%_!<L?Na(B
                    TMR1IE = 0;
                    TMR1IE = 0;                    
                    TMR1IE = 1;                 // $B%?%$%^(B1$B3d$j9~$_5v2D(B
                    TMR1ON = 1;                 // $B%?%$%^(B1$B%+%&%s%H3+;O(B
                }
                if(Interval > 50){              // 1$BIC8e$N>l9g(B
                    TMR1ON = 0;                 // $B%?%$%^#1Dd;_!J$3$N0LCV$,=EMW(B)                     
                    Interval = 0;               // 1$BIC%+%&%s%?%j%;%C%H(B
                    WaitFlag = 1;               // 1$BICBT$A%U%i%0%/%j%"(B
                    TMR1IE = 0;                 // $B%?%$%^(B1$B3d$j9~$_6X;_(B
                    TMR2IE = 0;                 // $B%?%$%^(B2$BDd;_(B
                }
            }
        }
    }
}
/******************************************************************/
/******************************************
* $B<~GH?t%+%&%s%?=hM}(B
*******************************************/
void FreqCounter(void){
    if(InitFlag == 0){                          // $B:G=i$N>l9g(B
        InitFlag = 1;                           // $B=i2s%U%i%0%/%j%"(B
        Freq = 0;                               // $B<~GH?tB,DjCM%/%j%"(B
        Interval = 0;                           // 1$BIC%+%&%s%?%j%;%C%H(B
        DACCON1 = 0x05;                         // $B%3%s%Q%l!<%?%9%l%C%7%g%k%I@_Dj(B
        WaitFlag = 0;                           // 1$BICBT$A%U%i%0%j%;%C%H(B
        Upper = 0;                              // $B%*!<%P!<%U%m!<%+%&%s%?%j%;%C%H(B
        /** $B%?%$%^#1=i4|@_Dj(B **/
        TMR1 = 0;                               // $B%?%$%^(B1$B%+%&%s%?%j%;%C%H(B
        T1CON = 0x85;                           // 1/1 T1CKI
        T2CON = 0x4F;                           // 1/64, 1/10
        PR2 = 249;                              // 20msec$B<~4|$H$9$k(B
        TMR2IF = 0;                             // $B3d$j9~$_%U%i%0%/%j%"(B
        TMR2IE = 1;                             // $B%?%$%^#23d$j9~$_5v2D(B
        PEIE = 1;                               // $B<~JU3d$j9~$_5v2D(B
        GIE = 1;                                // $B%0%m!<%P%k3d$j9~$_5v2D(B
    }
    else{                                       // $B7+$jJV$7$N>l9g(B
        while(WaitFlag == 0);                   // $B<~GH?t%+%&%s%HBT$A(B
        Freq = (Upper * 65536 + TMR1);          // $B<~GH?t<hF@(B
        ltostring(7, Freq, Dmsg+5);             // $BJ8;z$KJQ49(B
        Dmsg[0] = 'F';                          // $B8+=P$7(B
        Dmsg[1] = 'r';                          // $B!V(BFreq$B!W(B
        Dmsg[2] = 'e';
        Dmsg[3] = 'q';
        Dmsg[12] = 'H';                         // $BC10L!!(BHz
        Dmsg[13] = 'z';
        lcd_cmd(0xC0);                          // 2$B9TL\;XDj(B
        lcd_str(Dmsg);                          // $BI=<(<B9T(B
        /** $B:F7WB,$N$?$aJQ?t=i4|2=(B */
        Upper = 0;                              // $B%*!<%P!<%U%m!<%+%&%s%?%j%;%C%H(B
        TMR1 = 0;                               // $B%?%$%^(B1$B%+%&%s%?%j%;%C%H(B
        Interval = 0;                           // 0.5$BIC%+%&%s%?%j%;%C%H(B
        WaitFlag = 0;                           // 0.5$BICBT$A%U%i%0%j%;%C%H(B
        TMR2IE = 1;                             // $B%?%$%^(B2 $B:F%9%?!<%H(B
    }
}
/****************************************
* $B@589GH=PNO=hM}(B
*****************************************/
void SineOut(void){
    if(InitFlag == 0){                          // $B:G=i$N>l9g(B
        InitFlag = 1;                           // $B=i2s%U%i%0%/%j%"(B
        Cnt = 0;                                // $B%5%s%W%j%s%02s?t%+%&%s%?%/%j%"(B
        Index = 9;                              // $B=i4|CM(B100Hz$B$K%;%C%H(B
        OPTION_REG = Setting[Index][0];         // $B%W%j%9%1!<%i@_Dj(B
        TMR0 = Setting[Index][1];               // TMR0$B<~4|@_Dj(B
        TMR0IF = 0;                             // $B%?%$%^(B0$B3d$j9~$_%U%i%0%/%j%"(B
        TMR0IE = 1;                             // $B%?%$%^(B1 $B3d$j9~$_5v2D(B
        GIE = 1;                                // $B%0%m!<%P%k3d$j9~$_5v2D(B
    }
    /** $B<~GH?t$N(BLCD$BI=<((B ***/
    lcd_cmd(0xC0);                              // 2$B9TL\;XDj(B
    ltostring(4, SetFreq[Index], Dmsg+5);       // $B<~GH?t$rJ8;zNs$KJQ49$7%P%C%U%!$K3JG<(B
    Dmsg[0] = 'S';                              // $B8+=P$7I=<(%;%C%H(B
    Dmsg[1] = 'i';                              // $B!V(BSine$B!W(B
    Dmsg[2] = 'n';
    Dmsg[3] = 'e';
    Dmsg[9] = 'H';                              // $BC10L%;%C%H(B Hz
    Dmsg[10] = 'z';
    lcd_str(Dmsg);                              // LCD$BI=<(<B9T(B
}
/*****************************************
*  PSMC$B!!6k7AGH=PNO=hM}(B
*****************************************/
void PWMOutput(void){
       if(InitFlag == 0){                       // $B:G=i$N>l9g(B
            /** PSMC$B=i4|@_Dj(B ****/
            PSMC1CON = 0x40;                    // $B8GDj%G%e!<%F%#!"%7%s%0%k%b!<%I(B
            PSMC1STR0 = 0x20;                   // PSMC1 F only
            PSMC1CLK = 0x01;                    // Select 32MHz
            PSMC1OEN = 0x20;                    // F only Active
            PSMC1POL = 0;                       // Active High
            PSMC1DCS = 0x01;                    // $B%l%8%9%?$G;XDj(B
            PSMC1PRS = 0x01;                    // $B%l%8%9%?$G;XDj(B
            PSMC1PHS = 0x01;                    // $B%l%8%9%?$G;XDj(B
            PSMC1PHH = 0;                       // $B%U%'!<%:%7%U%H$J$7(B
            PSMC1PHL = 0;                       // $B%U%'!<%:%7%U%H$J$7(B
            InitFlag = 1;                       // $B=i2s%U%i%0%/%j%"(B
        }
       /** $B<~GH?t@_Dj(B ***/
        PSMC1PRH = (32000/Period-1) >> 8;       // $B<~4|>e0L%;%C%H(B
        PSMC1PRL = (32000/Period-1) & 0xFF;     // $B<~4|2<0L%;%C%H(B
        PSMC1DCH = (16000/Period-1) >> 8;       // $B%G%e!<%F%#>e0L%;%C%H(B
        PSMC1DCL = (16000/Period-1) & 0xFF;     // $B%G%e!<%F%#2<0L%;%C%H(B
        PSMC1EN = 1;                            // PSMC$BM-8z2=(B
        /** $B<~GH?t(BLCD$BI=<((B **/
        lcd_cmd(0xC0);                          // 2$B9TL\;XDj(B
        ltostring(4, (unsigned long)Period, Dmsg+5);    // $BJ8;z$KJQ49(B
        Dmsg[0] = 'R';                          // $B8+=P$7%;%C%H(B
        Dmsg[1] = 'e';                          // $B!V(BRect$B!W(B
        Dmsg[2] = 'c';
        Dmsg[3] = 't';
        Dmsg[9] = 'k';                          // $BC10L%;%C%H(B kHz
        Dmsg[10] = 'H';
        Dmsg[11] = 'z';
        lcd_str(Dmsg);                          // LCD$BI=<(<B9T(B
}
/*******************************************
*  $B%"%C%W%@%&%s%9%$%C%AF~NO=hM}(B
*******************************************/
void UpDownSW(void){
    /** $B%"%C%W%9%$%C%A=hM}(B **/
     if(PORTBbits.RB4 == 0){                    // $B%"%C%W%9%$%C%A(B $B%*%s$+!)(B
        switch(Mode){                           // $B%b!<%I$GJ,4t(B
            case 1:                             // $B@589GH=PNO$N>l9g(B
                if(Index < 18)                  // 18$B$h$j>.$5$$>l9g(B
                    Index++;                    // $B!\#1(B
                OPTION_REG = Setting[Index][0]; // $B%W%j%9%1!<%i@_Dj(B
                TMR0 = Setting[Index][1];       // TMR0$B<~4|@_Dj(B
                break;
            case 2:                             // $BJ}7AGH=PNO$N>l9g(B
                PSMC1EN = 0;                    // PSMC$B$$$C$?$sDd;_(B
                if(Period < 10)                 // $B<~4|(B10$B$h$j>.$5$$>l9g(B
                    Period += 1;                // $B<~4|(B+1
                else if(Period < 100)           // $B<~4|(B100$B$h$j>.$5$$>l9g(B
                    Period += 10;               // $B<~4|(B+10
                else if(Period < 1000)          // $B<~4|(B1000$B$h$j>.$5$$>l9g(B
                    Period += 100;              // $B<~4|(B+100
                else if(Period < 8000)          // $B<~4|(B8000$B$h$j>.$5$$>l9g(B
                    Period += 1000;             // $B<~4|(B+1000
                break;
            default:
                break;
        }
        while(PORTBbits.RB4 == 0);              // $B%A%c%?%j%s%0=hM}(B
    }
     /** $B%@%&%s%9%$%C%A=hM}(B ***/
    if(PORTBbits.RB5 == 0){                     // $B%@%&%s%9%$%C%A%*%s$+!)(B
        switch(Mode){                           // $B%b!<%I$GJ,4t(B
            case 1:                             // $B@589GH=PNO$N>l9g(B
              if(Index > 0)                     // 0$B$h$jBg$-$$>l9g(B
                Index--;                        // -1
                OPTION_REG = Setting[Index][0]; // $B%W%j%9%1!<%i@_Dj(B
                TMR0 = Setting[Index][1];       // TMR0$B<~4|@_Dj(B
                break;
            case 2:                             // $BJ}7AGH=PNO$N>l9g(B
                PSMC1EN = 0;                    // PSMC$B$$$C$?$sDd;_(B
                if(Period > 1000)               // $B<~4|(B1000$B$h$jBg$N>l9g(B
                    Period -= 1000;             // $B<~4|(B-1000
                else if(Period > 100)           // $B<~4|(B100$B$h$jBg$N>l9g(B
                    Period -= 100;              // $B<~4|(B-100
                else if(Period > 10)            // $B<~4|(B10$B$h$jBg$N>l9g(B
                    Period -= 10;               // $B<~4|(B-10
                else if(Period > 1)             // $B<~4|(B1$B$h$jBg$N>l9g(B
                    Period -= 1;                // $B<~4|(B-1
                break;
            default:
                break;
        }
        while(PORTBbits.RB5 == 0);              // $B%A%c%?%j%s%0=hM}(B
    }
}
/***************************************
*  A/D$BJQ49F~NO4X?t(B
****************************************/
unsigned int ADConv(unsigned char ch){
    int i;
    unsigned long value;

    ADCON0 = (ch << 2) | 0x01;                  // $B%A%c%M%kA*Br(B
    for(i=0; i<40; i++);                        // $B%"%/%$%8%7%g%s%?%$%`BT$A(B
    GO = 1;                                     // $BJQ493+;O(B
    while(GO);                                  // $BJQ49=*N;BT$A(B
    if((ADRESH & 0xF0)!= 0){                    // $BIi$N>l9g(B
        ADRESH = ~ADRESH;
        ADRESL = ~ADRESL;
        value = (ADRESH & 0x0F)*256 + ADRESL + 1;
        Cmsg[0] = '-';
    }
    else{
        value = (ADRESH & 0x0F)*256 + ADRESL;
        Cmsg[0] = '+';
    }
    return(value);                              // $BJQ497k2L$rJV$9(B
}
/***************************************
* $B@0?t$+$i(BASCII$BJ8;z$KJQ49(B
****************************************/
void ltostring(unsigned char digit, unsigned long data, unsigned char *buffer){
    unsigned char i;

    buffer += digit;                            // $B:G8e$N?t;z0LCV(B
    for(i=digit; i>0; i--) {                    // $BJQ49$O2<0L$+$i>e0L$X(B
        buffer--;                               // $B%]%$%s%?!<#1(B
        *buffer = (data % 10) + '0';            // ASCII$B$X(B
        data = data / 10;                       // $B<!$N7e$X(B
    }
}
